package lc.block;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.files.FileHandle;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import java.util.HashMap;

/**
 * @author Death
 */
public class BlocksTexture {

    public HashMap<String, Sprite> tex;
    public FileHandle path;
    public String[] names;
    
    public void setNames(String ... str){
        names = str;
    }
    
    public void setNames(String str){
        names = str.split(":");
    }
    
    public void setPath(String pa){
        this.path = Gdx.files.internal(pa);
    }
    
    public void load(){
        tex = new HashMap<>();
        Texture texture = new Texture(path);
        TextureRegion[][] regs = TextureRegion.split(texture, 64, 64);
        int indexName = 0;
        for(int i = 0; i < regs.length; i++){
            for(int j = 0; j < regs[i].length; j++){
                String nameB = "nullB";
                if(indexName < names.length)
                    nameB = names[indexName++];
                TextureRegion reg = regs[i][j];
                Sprite sp = new Sprite(reg);
                tex.put(nameB, sp);
            }
        }
    }
    
    public Sprite get(String name){
        return tex.get(name);
    }
}
