package lc.game;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Input.Keys;
import com.badlogic.gdx.InputProcessor;
import com.badlogic.gdx.Screen;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import lc.block.Block;
import lc.world.World;
import lc.utils.WCamera;
import lc.world.objectes.TypeObjectWorld;
import lc.world.objectes.WorldObject;
import org.lwjgl.opengl.GL11;

/**
 * @author Death
 */
public class GameScreen implements Screen, InputProcessor{

    World world;
    public WCamera camera;
    public SpriteBatch batch;
    WorldObject player;
    
    @Override
    public void show(){
        camera = new WCamera();
        camera.setToOrtho(false, Gdx.graphics.getWidth(), Gdx.graphics.getHeight());
        batch = new SpriteBatch();
        Block.load(Gdx.files.internal("res/blocks.json"));
        world = new World(700, 500);
        
        for(int i = 0; i < world.widthBlock; i++){
            for(int j = 0; j < world.heightBlock / 2; j++){
                world.ground.blocks[i][j] = Block.get("dirst");
            }
        }
        for(int i = 0; i < world.widthBlock; i++){
            world.ground.blocks[i][world.heightBlock / 2 - 1] = Block.get("grass");
        }
        Sprite s = new Sprite(new Texture(Gdx.files.internal("res/objGame.png")));
        
        player = new WorldObject();
        player.sprite = s;
        player.width = 60;
        player.height = 60;
        player.y = world.heightBlock / 2 * Block.SIZE + Block.SIZE * 3;
        player.initPhysics(world);
        player.type = TypeObjectWorld.DYNAMIC;
        
        world.add(player);
        
        Gdx.input.setInputProcessor(this);
    }

    @Override
    public void render(float f){
        GL11.glClear(GL11.GL_COLOR_BUFFER_BIT);
        
        camera.position.set(player.x, player.y, 0);
        camera.update();
        batch.setProjectionMatrix(camera.combined);
        
        batch.begin();
        world.draw(camera, batch);
        batch.end();
        
        player.move(f);
//        player.moveY(-5);
    }

    @Override
    public void resize(int i, int i1){
    }

    @Override
    public void pause(){
    }

    @Override
    public void resume(){
    }

    @Override
    public void hide(){
    }

    @Override
    public void dispose(){
    }

    @Override
    public boolean keyDown(int i){
        switch(i){
            case Keys.W: player.moveKey[WorldObject.UP] = true; break;
            case Keys.S: player.moveKey[WorldObject.DOWN] = true; break;
            case Keys.D: player.moveKey[WorldObject.RIGHT] = true; break;
            case Keys.A: player.moveKey[WorldObject.LEFT] = true; break;
        }
        return false;
    }

    @Override
    public boolean keyUp(int i){
        switch(i){
            case Keys.W: player.moveKey[WorldObject.UP] = false; break;
            case Keys.S: player.moveKey[WorldObject.DOWN] = false; break;
            case Keys.D: player.moveKey[WorldObject.RIGHT] = false; break;
            case Keys.A: player.moveKey[WorldObject.LEFT] = false; break;
        }
        return false;
    }

    @Override
    public boolean keyTyped(char c){
        return false;
    }

    @Override
    public boolean touchDown(int i, int i1, int i2, int i3){
        return false;
    }

    @Override
    public boolean touchUp(int i, int i1, int i2, int i3){
        return false;
    }

    @Override
    public boolean touchDragged(int i, int i1, int i2){
        return false;
    }

    @Override
    public boolean mouseMoved(int i, int i1){
        return false;
    }

    @Override
    public boolean scrolled(int i){
        return false;
    }

}
