package lc.menu;

import com.badlogic.gdx.Game;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Screen;
import com.badlogic.gdx.graphics.OrthographicCamera;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.Stage;
import com.badlogic.gdx.scenes.scene2d.ui.TextButton;
import com.badlogic.gdx.scenes.scene2d.utils.ClickListener;
import lc.Asset;
import lc.MyGame;
import lc.game.GameScreen;
import org.lwjgl.opengl.GL11;

/**
 * @author Death
 */
public class MenuScreen implements Screen{

    public OrthographicCamera camera;
    public SpriteBatch batch;
    public Stage stage;
    
    @Override
    public void show(){
        GL11.glClearColor(0, 0, 0.3f, 1);
        camera = new OrthographicCamera();
        camera.setToOrtho(false, Gdx.graphics.getWidth(), Gdx.graphics.getHeight());
        batch = new SpriteBatch();
        
        stage = new Stage();
        
        TextButton newGame = new TextButton("Новая игра", Asset.skinUI, "default-small");
        newGame.setSize(200, 30);
        newGame.setPosition(Gdx.graphics.getWidth() / 2 - newGame.getWidth() / 2,
                            Gdx.graphics.getHeight() - 10 - newGame.getHeight());
        newGame.addListener(new ClickListener(){
            @Override
            public void clicked(InputEvent event, float x, float y){
                MyGame.game.setScreen(new GameScreen());
            }
        });
        stage.addActor(newGame);
        
        Gdx.input.setInputProcessor(stage);
    }

    @Override
    public void render(float f){
        GL11.glClear(GL11.GL_COLOR_BUFFER_BIT);
        
        camera.update();
        
        stage.act();
        stage.draw();
    }

    @Override
    public void resize(int i, int i1){
    }

    @Override
    public void pause(){
    }

    @Override
    public void resume(){
    }

    @Override
    public void hide(){
    }

    @Override
    public void dispose(){
    }

}
