package lc.world;

import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import lc.block.Block;
import lc.utils.WCamera;

/**
 * @author Death
 */
public class Ground {

    public Block[][] blocks;
    public World world;

    public Ground(World world){
        this.world = world;
        this.blocks = new Block[world.widthBlock][world.heightBlock];
        for(int i = 0; i < world.widthBlock; i++){
            for(int j = 0; j < world.heightBlock; j++){
                blocks[i][j] = null;
            }
        }
    }
    
    public void draw(WCamera cam, SpriteBatch b){
        int xi = (int) (cam.getX() / Block.SIZE) - 2;
        int yi = (int) (cam.getY() / Block.SIZE) - 2;
        int wi = (int) (cam.getWidth() / Block.SIZE) + 5;
        int hi = (int) (cam.getHeight() / Block.SIZE) + 5;
        if(xi < 0) xi = 0;
        if(yi < 0) yi = 0;
        if(xi + wi > world.widthBlock) wi = world.widthBlock - xi;
        if(yi + hi > world.heightBlock) hi = world.heightBlock - yi;
        
        for(int i = xi; i < xi + wi; i++){
            for(int j = yi; j < yi + hi; j++){
                if(blocks[i][j] == null) continue;
                Block block = blocks[i][j];
                Sprite sp = Block.texture.get(block.nameTexture);
                sp.setPosition(Block.SIZE * i, Block.SIZE * j);
                sp.setSize(Block.SIZE, Block.SIZE);
                sp.setOriginCenter();
                sp.setRotation(block.rotate);
                sp.draw(b);
//                b.draw(reg, Block.SIZE * i, Block.SIZE * j, Block.SIZE, Block.SIZE);
            }
        }
    }
    
    public Block getBlock(int x, int y){
        return blocks[x][y];
    }
}
