package lc.world;

import lc.world.objectes.WorldObject;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import com.badlogic.gdx.math.Rectangle;
import java.util.ArrayList;
import lc.block.Block;
import lc.utils.WCamera;

/**
 * @author Death
 */
public class World {

    public int widthBlock, heightBlock;
    public WorldGridObject gridObject;
    public ArrayList<WorldObject> objectes = new ArrayList<>();
    public Ground ground;

    public World(int widthBlock, int heightBlock){
        this.widthBlock = widthBlock;
        this.heightBlock = heightBlock;
        gridObject = new WorldGridObject(Block.SIZE * 10, this.getWidth(), this.getHeight());
        ground = new Ground(this);
    }
    
    public void draw(WCamera cam, SpriteBatch b){
        ground.draw(cam, b);
        this.drawObject(cam, b);
    }
    
    public void drawObject(WCamera cam, SpriteBatch b){
        Rectangle.tmp2.set(cam.getX(), cam.getY(), cam.getWidth(), cam.getHeight());
        ArrayList<WorldObject> objs = gridObject.getObjectes(Rectangle.tmp2);
        gridObject.updateDynamic();
        objs.forEach(ob -> ob.draw(b));
    }
    
    public void add(WorldObject ob){
        this.objectes.add(ob);
        this.gridObject.add(ob);
    }
    
    public void remove(WorldObject ob){
        this.objectes.remove(ob);
        this.gridObject.removeObject(ob);
    }
    
    public int getWidth(){
        return widthBlock * Block.SIZE;
    }
    
    public int getHeight(){
        return heightBlock * Block.SIZE;
    }
    
    
}
